Index: trunk/kernel/devices/dev_nic.c
===================================================================
--- trunk/kernel/devices/dev_nic.c	(revision 674)
+++ trunk/kernel/devices/dev_nic.c	(revision 683)
@@ -1,3 +1,2 @@
-
 /*
  * dev_nic.c - NIC (Network Controler) generic device API implementation.
@@ -46,4 +45,8 @@
 void dev_nic_init( chdev_t * chdev )
 {
+
+assert( __FUNCTION__ , (chdev->func == DEV_FUNC_NIC) , 
+"bad func value");
+
     thread_t * new_thread;
     error_t    error;
@@ -74,10 +77,10 @@
 
     // build pointer on server function
-    void * func = is_rx ? &dev_nic_rx_server : &dev_nic_tx_server;
+    void * server_func = is_rx ? &dev_nic_rx_server : &dev_nic_tx_server;
 
     // create server thread
     error = thread_kernel_create( &new_thread,
                                   THREAD_DEV,
-                                  func,
+                                  server_func,
                                   chdev,
                                   lid ); 
@@ -120,8 +123,18 @@
     thread_t * this = CURRENT_THREAD;
     
-    xptr_t dev_xp = chdev_dir.nic_tx[0];
+    // get cluster and local pointer fo the nic_tx[0] chdev
+    xptr_t    dev_xp  = chdev_dir.nic_tx[0];
     chdev_t * dev_ptr = GET_PTR( dev_xp );
-
-    if( dev_xp == XPTR_NULL ) return -1;
+    cxy_t     dev_cxy = GET_CXY( dev_xp );
+
+    if( dev_xp == XPTR_NULL )
+    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : nic_tx[0] chdev undefined in chdev_dir of cluster %x\n",
+__FUNCTION__, local_cxy );
+#endif
+        return -1;
+    }
     
     // set command arguments in client thread descriptor
@@ -131,10 +144,14 @@
     this->nic_cmd.type   = NIC_CMD_GET_KEY;
 
+    // get cmd function pointer from nic_tx[0] chdev descriptor
+    dev_cmd_t * cmd = hal_remote_lpt( XPTR( dev_cxy , &dev_ptr->cmd ));
+    
     // call driver 
-    dev_ptr->cmd( XPTR( local_cxy , this ) );
-
-    // get "status" 
+    cmd( XPTR( local_cxy , this ) );
+
+    // return command status 
     return this->nic_cmd.status;
-}
+
+}  // end dev_nic_get_key()
 
 //////////////////////////////////////////
@@ -146,8 +163,18 @@
     if( channel >= LOCAL_CLUSTER->nb_nic_channels ) return -1;
 
-    xptr_t    dev_xp  = chdev_dir.nic_tx[0];
+    // get cluster and local pointer fo the nic_tx[channel] chdev
+    xptr_t    dev_xp  = chdev_dir.nic_tx[channel];
     chdev_t * dev_ptr = GET_PTR( dev_xp );
-
-    if( dev_xp == XPTR_NULL ) return -1;
+    cxy_t     dev_cxy = GET_CXY( dev_xp );
+
+    if( dev_xp == XPTR_NULL ) 
+    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : nic_tx[%d] chdev undefined in chdev_dir of cluster %x\n",
+__FUNCTION__, channel, local_cxy );
+#endif
+        return -1;
+    }
     
     // set command arguments in client thread descriptor
@@ -157,10 +184,14 @@
     this->nic_cmd.status = run;
 
+    // get cmd function pointer from nic_tx[channel] chdev descriptor
+    dev_cmd_t * cmd = hal_remote_lpt( XPTR( dev_cxy , &dev_ptr->cmd ));
+    
     // call driver 
-    dev_ptr->cmd( XPTR( local_cxy , this ) );
+    cmd( XPTR( local_cxy , this ) );
 
     // return "error" 
     return this->nic_cmd.error;
-}
+
+}  // end dev_nic_set_run()
 
 //////////////////////////////////
@@ -169,8 +200,18 @@
     thread_t * this = CURRENT_THREAD;
 
+    // get cluster and local pointer fo the nic_tx[0] chdev
     xptr_t    dev_xp  = chdev_dir.nic_tx[0];
     chdev_t * dev_ptr = GET_PTR( dev_xp );
+    cxy_t     dev_cxy = GET_CXY( dev_xp );
     
-    if( dev_xp == XPTR_NULL ) return -1;
+    if( dev_xp == XPTR_NULL ) 
+    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : nic_tx[0] chdev undefined in chdev_dir of cluster %x\n",
+__FUNCTION__, local_cxy );
+#endif
+        return -1;
+    }
     
     // set command arguments in client thread descriptor
@@ -178,10 +219,15 @@
     this->nic_cmd.type   = NIC_CMD_GET_INSTRU;
 
+    // get cmd function pointer from nic_tx[0] chdev descriptor
+    dev_cmd_t * cmd = hal_remote_lpt( XPTR( dev_cxy , &dev_ptr->cmd ));
+    
     // call driver 
-    dev_ptr->cmd( XPTR( local_cxy , this ) );
+    cmd( XPTR( local_cxy , this ) );
 
     // return "error" 
     return this->nic_cmd.error;
-}
+
+}  // end dev_nic_get_instru()
+
 
 ////////////////////////////////////
@@ -190,8 +236,18 @@
     thread_t * this = CURRENT_THREAD;
 
+    // get cluster and local pointer fo the nic_tx[0] chdev
     xptr_t    dev_xp  = chdev_dir.nic_tx[0];
     chdev_t * dev_ptr = GET_PTR( dev_xp );
+    cxy_t     dev_cxy = GET_CXY( dev_xp );
     
-    if( dev_xp == XPTR_NULL ) return -1;
+    if( dev_xp == XPTR_NULL ) 
+    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : nic_tx[0] chdev undefined in chdev_dir of cluster %x\n",
+__FUNCTION__, local_cxy );
+#endif
+        return -1;
+    }
     
     // set command arguments in client thread descriptor
@@ -199,10 +255,14 @@
     this->nic_cmd.type   = NIC_CMD_GET_INSTRU;
 
+    // get cmd function pointer from nic_tx[0] chdev descriptor
+    dev_cmd_t * cmd = hal_remote_lpt( XPTR( dev_cxy , &dev_ptr->cmd ));
+    
     // call driver 
-    dev_ptr->cmd( XPTR( local_cxy , this ) );
+    cmd( XPTR( local_cxy , this ) );
 
     // return "error" 
     return this->nic_cmd.error;
-}
+
+}  // end dev_nic_clear_instru()
 
 
@@ -261,62 +321,21 @@
 
 ////////////////////////////////////////////////////////////////////////////////////////
-// This static function computes the checksum for an UDP packet defined by 
-// the <buffer> and <size> arguments.
+// This static function computes the checksum for a TCP segment or an UDP packet,
+// defined by the <buffer> and <length> arguments. 
+// It includes the "pseudo header "defined by the <src_ip_addr>, <dst_ip_addr>, and
+// <tcp_length> arguments, and by the UDP/TCP protocol code.
 ////////////////////////////////////////////////////////////////////////////////////////
-// @ buffer      : [in] pointer on UDP packet base.
-// @ size        : [in] number of bytes in this packet (including header).
+// @ buffer      : [in] pointer on buffer containing the TCP segment or UDP packet.
+// @ length      : [in] number of bytes in this packet/segment (including header).
+// @ src_ip_addr : [in] source IP address (pseudo header).
+// @ dst_ip_addr : [in] destination IP address (pseudo header).
+// @ is_tcp      : [in] TCP if true / UDP if false (pseudo header).
 // @ return the checksum value on 16 bits
 ////////////////////////////////////////////////////////////////////////////////////////
-static uint16_t dev_nic_udp_checksum( uint8_t  * buffer,
-                                      uint32_t   size )
-{
-    uint32_t   i;           
-    uint32_t   carry;
-    uint32_t   cs;      // 32 bits accumulator
-    uint16_t * buf;     
-    uint32_t   max;     // number of uint16_t in packet
-    
-    // compute max & buf
-    buf = (uint16_t *)buffer;
-    max = size >> 1;
-
-    // extend buffer[] if required
-    if( size & 1 )
-    {
-        max++;
-        buffer[size] = 0;
-    }
-
-    // compute checksum for UDP packet
-    for( i = 0 , cs = 0 ; i < size ; i++ )  cs += buf[i];
-
-    // handle carry
-    carry = (cs >> 16);
-    if( carry ) 
-    {
-        cs += carry; 
-        carry = (cs >> 16);
-        if( carry ) cs += carry;
-    } 
-
-    // one's complement
-    return ~cs;
-}
-
-////////////////////////////////////////////////////////////////////////////////////////
-// This static function computes the checksum for a TCP segment defined by the <buffer> 
-// and <size> arguments. It includes the pseudo header defined by the <src_ip_addr>,
-// <dst_ip_addr>, <size> arguments, and by the TCP_PROTOCOL code.
-////////////////////////////////////////////////////////////////////////////////////////
-// @ buffer      : [in] pointer on TCP segment base.
-// @ tcp_length  : [in] number of bytes in this TCP segment (including header).
-// @ src_ip_addr : [in] source IP address (pseudo header)
-// @ dst_ip_addr : [in] destination IP address (pseudo header)
-// @ return the checksum value on 16 bits
-////////////////////////////////////////////////////////////////////////////////////////
-static uint16_t dev_nic_tcp_checksum( uint8_t  * buffer,
-                                      uint32_t   tcp_length,
-                                      uint32_t   src_ip_addr,
-                                      uint32_t   dst_ip_addr )
+static uint16_t dev_nic_tcp_udp_checksum( uint8_t  * buffer,
+                                          uint32_t   length,
+                                          uint32_t   src_ip_addr,
+                                          uint32_t   dst_ip_addr,
+                                          bool_t     is_tcp )
 {
     uint32_t   i;           
@@ -324,25 +343,27 @@
     uint32_t   cs;      // 32 bits accumulator
     uint16_t * buf;
-    uint32_t   max;     // number of uint16_t in segment
+    uint32_t   max;     // number of uint16_t in segment/paket
 
     // compute max & buf
     buf = (uint16_t *)buffer;
-    max = tcp_length >> 1;
+    max = length >> 1;
 
     // extend buffer[] if required
-    if( tcp_length & 1 )
+    if( length & 1 )
     {
         max++;
-        buffer[tcp_length] = 0;
+        buffer[length] = 0;
     }
 
     // compute checksum for TCP segment
-    for( i = 0 , cs = 0 ; i < tcp_length ; i++ )  cs += buf[i];
+    for( i = 0 , cs = 0 ; i < max ; i++ )  cs += buf[i];
 
     // complete checksum for pseudo-header
-    cs += src_ip_addr;
-    cs += dst_ip_addr;
-    cs += PROTOCOL_TCP;
-    cs += tcp_length;
+    cs += (src_ip_addr & 0xFFFF);
+    cs += (src_ip_addr >> 16 );
+    cs += (dst_ip_addr & 0xFFFF);
+    cs += (dst_ip_addr >> 16 );
+    cs += length;
+    cs += (is_tcp ? PROTOCOL_TCP : PROTOCOL_UDP);
 
     // handle carry
@@ -360,10 +381,10 @@
 
 ///////////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the NIC_TX or NIC_RX server threads to unblock
+// This static function is called by the NIC_TX and NIC_RX server threads to unblock
 // the TX client thread after completion (success or error) of a TX command registered
-// in a socket identified by the <socket_xp> argument. The <status> argument defines
-// the command success/failure status: a null value signals a success, a non-null value
-// signals a failure. For all commands, it copies the status value in the tx_sts field,
-// and print an error message on TXT0 in case of failure.
+// in a socket identified by the <socket_xp> argument. 
+// The <status> argument defines the command success/failure status.
+// For all commands, it copies the status value in the tx_sts field, and print an error 
+// message on TXT0 in case of failure.
 ///////////////////////////////////////////////////////////////////////////////////////////
 // @ socket_xp  : [in] extended pointer on socket
@@ -377,5 +398,5 @@
     cxy_t      socket_cxy = GET_CXY( socket_xp );
 
-    if( status != CMD_STS_SUCCESS )
+    if( (status != CMD_STS_SUCCESS) && (status != CMD_STS_EOF) )
     {
         uint32_t sock_state = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->state ));
@@ -400,11 +421,16 @@
 }  // end dev_nic_unblock_tx_client()
 
-///////////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the NIC_TX or NIC_RX server threads to unblock
+
+///////////////////////////////////////////////////////////////////////////////////////////
+//               Functions called by the NIC_RX server thread
+///////////////////////////////////////////////////////////////////////////////////////////
+
+///////////////////////////////////////////////////////////////////////////////////////////
+// This static function is called by the NIC_RX server threads to unblock
 // the RX client thread after completion (success or error) of an RX command registered
-// in a socket identified by the <socket_xp> argument. The <status> argument defines
-// the command success/failure status: a null value signals a success, a non-null value
-// signals a failure. For all commands, it copies the status value in the rx_sts field,
-// and print an error message on TXT0 in case of failure.
+// in a socket identified by the <socket_xp> argument.
+// The <status> argument defines the command success/failure status. 
+// For all commands, it copies the status value in the rx_sts field, and print an error 
+// message on TXT0 in case of failure.
 ///////////////////////////////////////////////////////////////////////////////////////////
 // @ socket_xp  : [in] extended pointer on socket
@@ -418,5 +444,5 @@
     cxy_t      socket_cxy = GET_CXY( socket_xp );
 
-    if( status != CMD_STS_SUCCESS )
+    if( (status != CMD_STS_SUCCESS) && (status != CMD_STS_EOF) )
     {
         uint32_t sock_state = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->state ));
@@ -440,8 +466,4 @@
 
 }  // end dev_nic_unblock_rx_client()
-
-///////////////////////////////////////////////////////////////////////////////////////////
-//               Functions called by the NIC_RX server thread
-///////////////////////////////////////////////////////////////////////////////////////////
 
 ///////////////////////////////////////////////////////////////////////////////////////////
@@ -553,5 +575,6 @@
    
     return 0;
-}
+
+}   // end dev_nic_rx_check_ip()
 
 ///////////////////////////////////////////////////////////////////////////////////////////
@@ -595,6 +618,7 @@
     xptr_t     socket_rbuf_xp;    // extended pointer on socket rx_buf
     xptr_t     socket_lock_xp;    // extended pointer on socket lock
-    xptr_t     socket_client_xp;  // extended pointer on socket rx_client field
-    xptr_t     client_xp;         // extended pointer on client thread descriptor
+    xptr_t     socket_rx_client;  // socket rx_client thread
+    bool_t     socket_rx_valid;   // socket rx_command valid
+    uint32_t   socket_rx_cmd;     // socket rx_command type
     uint32_t   payload;           // number of bytes in payload
     uint32_t   status;            // number of bytes in rx_buf
@@ -602,16 +626,48 @@
     uint32_t   moved_bytes;       // number of bytes actually moved to rx_buf
 
+#if DEBUG_DEV_NIC_RX || DEBUG_DEV_NIC_ERROR
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+#endif
+
+#if DEBUG_DEV_NIC_RX
+uint32_t   fdid;
+uint32_t   pid;
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] thread[%x,%x] enter / channel %d / plen %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, chdev->channel, k_length, cycle );
+if( (DEBUG_DEV_NIC_RX < cycle) && (DEBUG_DEV_NIC_RX & 1))
+putb("64 first bytes in k_buf" , k_buf , 64 );
+#endif
+
     // build extended pointers on list of sockets attached to NIC_RX chdev
     root_xp = XPTR( local_cxy , &chdev->wait_root );
     lock_xp = XPTR( local_cxy , &chdev->wait_lock );
 
-    // compute UDP packet checksum 
-    checksum = dev_nic_udp_checksum( k_buf , k_length );
-
-    // get checksum from received packet header 
+    // extract checksum from received UDP packet header 
     pkt_checksum = ((uint16_t)k_buf[6] << 8) | (uint16_t)k_buf[7];
 
+    // reset checksum field
+    k_buf[6] = 0;
+    k_buf[7] = 0; 
+
+    // compute checksum from received UDP packet
+    checksum = dev_nic_tcp_udp_checksum( k_buf,
+                                         k_length,
+                                         pkt_src_addr,
+                                         pkt_dst_addr,
+                                         false );        // is_not_tcp
     // discard corrupted packet  
-    if( pkt_checksum != checksum ) return;
+    if( pkt_checksum != checksum )
+    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[WARNING] in %s : thread[%x,%x] discard corrupted packet on channel %d / cycle %d\n"
+"   expected checksum %x / received checksum %x\n",
+__FUNCTION__, this->process->pid, this->trdid, chdev->channel, cycle,
+(uint32_t)checksum, (uint32_t)pkt_checksum ); 
+#endif
+        return;
+    }
     
     // get src_port and dst_port from UDP header
@@ -619,7 +675,4 @@
     uint32_t pkt_dst_port = ((uint32_t)k_buf[2] << 8) | (uint32_t)k_buf[3];
 
-    // discard unexpected packet
-    if( xlist_is_empty( root_xp ) ) return;
- 
     // take the lock protecting the sockets list
     remote_busylock_acquire( lock_xp );
@@ -658,6 +711,17 @@
         else                                  match_socket = local_match;
 
-        // exit loop when socket found
-        if( match_socket ) break;
+        // exit loop if matching
+        if( match_socket ) 
+        {
+
+#if DEBUG_DEV_NIC_RX
+fdid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ) );
+pid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ) );
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] thread[%x,%x] found matching UDP socket[%d,%d] / state %s\n",
+__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state) );
+#endif
+            break;
+        }
     }
 
@@ -666,10 +730,17 @@
 
     // discard unexpected packet
-    if( match_socket == false ) return;
-   
-    // build extended pointers on various socket fields
+    if( match_socket == false )
+    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[WARNING] in %s : thread[%x,%s] discard unexpected packet on channel %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, chdev->channel, cycle ); 
+#endif
+        return;
+    }
+ 
+    // build extended pointers on socket.rx_buf and socket.lock
     socket_rbuf_xp   = XPTR( socket_cxy , &socket_ptr->rx_buf );
     socket_lock_xp   = XPTR( socket_cxy , &socket_ptr->lock ); 
-    socket_client_xp = XPTR( socket_cxy , &socket_ptr->rx_client );
 
     // take the lock protecting the socket 
@@ -678,8 +749,10 @@
     // get status & space from rx_buf
     status = remote_buf_status( socket_rbuf_xp );
-    space  = CONFIG_SOCK_RX_BUF_SIZE - status;
-
-    // get client thread 
-    client_xp  = hal_remote_l64( socket_client_xp );
+    space  = (1 << CONFIG_SOCK_RX_BUF_ORDER) - status;
+
+    // get socket rx_client, rx_valid and rx_cmd values
+    socket_rx_client = hal_remote_l64( XPTR( socket_cxy , &socket_ptr->rx_client ) );
+    socket_rx_valid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->rx_valid ) );
+    socket_rx_cmd    = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->rx_cmd ) );
 
     // get number of bytes in payload
@@ -691,10 +764,40 @@
     // move payload from kernel buffer to socket rx_buf
     remote_buf_put_from_kernel( socket_rbuf_xp,
-                                 k_buf + UDP_HEAD_LEN,
-                                 moved_bytes );
-    // unblock client thread 
-    if( client_xp != XPTR_NULL )
-    {
-        thread_unblock( client_xp , THREAD_BLOCKED_IO );
+                                k_buf + UDP_HEAD_LEN,
+                                moved_bytes );
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] thread[%x,%x] for socket[%d,%d] move %d bytes to rx_buf / buf_sts %d\n",
+__FUNCTION__, this->process->pid, this->trdid, pid, fdid, 
+moved_bytes, remote_buf_status(socket_rbuf_xp), moved_bytes );
+#endif
+
+    // signal client thread if pending RECV command
+    if( (socket_rx_valid == true) && (socket_rx_cmd == CMD_RX_RECV) )
+    {
+        // reset rx_valid
+        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->rx_valid), false );
+
+        // report success to RX client thread
+        dev_nic_unblock_rx_client( socket_xp , CMD_STS_SUCCESS );
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] thread[%x,%x] for UDP socket[%x,%d] / unblock client thread\n",
+__FUNCTION__, this->process->pid, this->trdid, pid, fdid );
+#endif
+
+    }
+    else
+    {
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] thread[%x,%x] for socket[%x,%d] / no client thread\n"
+"    rx_valid %d / rx_cmd %s\n",
+__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
+socket_rx_valid , socket_cmd_type_str(socket_rx_cmd) );
+#endif
+
     }
 
@@ -707,10 +810,14 @@
 // This static function is called by the dev_nic_rx_server() function to handle one RX
 // TCP segment contained in a kernel buffer defined by the <k_buf> & <k_length> arguments.
-// The <seg_remote_addr> and <seg_local_addr> arguments are obtained from the received
-// IP packet header. It the received segment doesn't match any connected socket attached
-// to the selected chdev[k], or any listening socket waiting connection, or if the segment
-// is corrupted, this segment is discarded. 
-// If required by the TCP flags, it registers an R2T request in the socket R2T queue 
-// to implement the TCP handcheck for close and connect.
+// The <seg_remote_addr> and <seg_local_addr> arguments have been extracted from the IP
+// IP header. The local and remote ports are obtained from the TCP header.
+// It the received segment doesn't match any connected socket attached to the selected 
+// <chdev>, or any listening socket waiting connection, or if the segment is corrupted,
+// the segment is discarded. This function implement the TCP error recovery protocol,
+// as specified by the RFC. Depending on both the socket state, and the segment header:
+//  - it register data in the RX buffer,
+//  - it update the socket state and TCB,
+//  - it register acknolegce requests in the R2T queue,
+//  - it register connection requests in the CRQ queue,
 ///////////////////////////////////////////////////////////////////////////////////////////
 // Implementation note:
@@ -724,5 +831,5 @@
 //    the SYN, FIN, ACK and RST flags. It updates the socket state when required, moves 
 //    data to the rx_buf when possible, and return. It takes the lock protecting the socket,
-//    because an connected socket is accessed by both the NIC_TX and NIC_RX server threads.
+//    because a connected socket is accessed by both the NIC_TX and NIC_RX server threads.
 // 4) If no matching connected socket has been found, it scans the list of listening 
 //    sockets to find a matching listening socket. 
@@ -760,7 +867,8 @@
     bool_t     socket_tx_valid;    // TX command valid
     uint32_t   socket_tx_cmd;      // TX command type
-    uint32_t   socket_tx_todo;     // number of TX bytes not sent yet 
     uint32_t   socket_tx_nxt;      // next byte to send in TX stream
     uint32_t   socket_tx_una;      // first unacknowledged byte in TX stream
+    uint32_t   socket_tx_len;      // number of bytes in tx_buf
+    uint32_t   socket_tx_ack;      // number of acknowledged bytes in tx_buf
     bool_t     socket_rx_valid;    // RX command valid
     uint32_t   socket_rx_cmd;      // TX command type
@@ -804,48 +912,51 @@
     uint32_t seg_data_len = k_length - seg_hlen;  // number of bytes in payload
 
-#if DEBUG_DEV_NIC_RX
-thread_t * this = CURRENT_THREAD;
-uint32_t   cycle;
+    uint32_t seg_data_dup;     // number of duplicated bytes in payload
+    uint32_t seg_data_new;     // number of new bytes in payload
+
+#if DEBUG_DEV_NIC_RX || DEBUG_DEV_NIC_ERROR
 uint32_t   fdid;
 pid_t      pid;
-#endif
-
-#if DEBUG_DEV_NIC_RX
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_RX )
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+#endif
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
 printk("\n[%s] thread[%x,%x] enters / tcp_length %d / tcp_flags %x / cycle %d\n",
 __FUNCTION__, this->process->pid, this->trdid, k_length, seg_flags , cycle );
 #endif
 
-    // compute and check TCP checksum
+    // reset checksum field
     k_buf[16] = 0;
     k_buf[17] = 0;
-    checksum = dev_nic_tcp_checksum( k_buf,
-                                     k_length,
-                                     seg_remote_addr,
-                                     seg_local_addr );
-
+
+    // compute TCP checksum
+    checksum = dev_nic_tcp_udp_checksum( k_buf,
+                                         k_length,
+                                         seg_remote_addr,
+                                         seg_local_addr,
+                                         true );            // is_tcp
     // discard segment if corrupted 
     if( seg_checksum != checksum )
     {
 
-#if DEBUG_DEV_NIC_RX
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] tcp checksum failure : received %x / computed %x\n",
-__FUNCTION__, this->process->pid, this->trdid, seg_checksum, checksum );
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[WARNING] in %s : thread[%x,%x] / checksum failure on channel %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, chdev->channel, cycle );
 #endif
         return;
     }
     
-    // scan list of attached sockets to find a matching TCP socket
-    attached_match = false;
-
     // build extended pointer on xlist of sockets attached to NIC_RX chdev
     root_xp = XPTR( local_cxy , &chdev->wait_root );
     lock_xp = XPTR( local_cxy , &chdev->wait_lock );
 
+    attached_match = false;
+
     // take the lock protecting the list of attached sockets
     remote_busylock_acquire( lock_xp );
 
+    // scan list of attached sockets to find a matching TCP socket
     XLIST_FOREACH( root_xp , iter_xp )
     {
@@ -878,10 +989,13 @@
         {
 
-#if DEBUG_DEV_NIC_RX
-fdid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ) );
-pid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ) );
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] matching attached socket[%d,%d] / state %s\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state) );
+#if DEBUG_DEV_NIC_RX || DEBUG_DEV_NIC_ERROR
+fdid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ) );
+pid   = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ) );
+#endif
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] matching attached TCP socket[%d,%d] / state %s\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
 #endif
             break;
@@ -912,7 +1026,8 @@
         socket_tx_valid = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_valid ));
         socket_tx_cmd   = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_cmd ));
-        socket_tx_todo  = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_todo ));
         socket_tx_nxt   = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_nxt )); 
         socket_tx_una   = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_una ));
+        socket_tx_ack   = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_ack ));
+        socket_tx_len   = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->tx_len ));
 
         socket_rx_valid = hal_remote_l32(XPTR( socket_cxy , &socket_ptr->rx_valid ));
@@ -926,47 +1041,55 @@
         {
             ////////////////////////
-            case TCP_STATE_SYN_SENT:  // TCP client waiting for SYN-ACK in connect handshake
+            case TCP_STATE_SYN_SENT:  // TCP client waiting for SYN-ACK 
             {
-                // [1] check ACK flag 
+                // [1] & [2] check ACK and RST
                 if( seg_ack_set )
                 {
-                    if( seg_ack_num != TCP_ISS_CLIENT + 1 )  // bad ACK => report error
+                    bool_t ack_ok = (seg_ack_num == (CONFIG_SOCK_ISS_CLIENT + 1) );
+
+                    if( seg_rst_set && ack_ok )
                     {
 
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : expect ack_num %x / get %x\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state), TCP_ISS_CLIENT + 1, seg_ack_num );
-#endif
-                        // make an RST request to R2T queue
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s]  socket[%x,%d] %s RST received from remote TCP => close\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                        // report RST to local TCP client thread
+                        dev_nic_unblock_tx_client( socket_xp , CMD_STS_RST );
+
+                        // update socket state
+                        hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ),
+                                          TCP_STATE_BOUND );
+                        break;
+                    }
+
+                    if( seg_rst_set && (ack_ok == false) )
+                    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s RST but expect ack_num %x != rcvd %x => discard\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state),
+CONFIG_SOCK_ISS_CLIENT + 1, seg_ack_num );
+#endif
+                        break;
+                    }
+
+                    if( (seg_rst_set == false) && (ack_ok == false) )
+                    {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s expected ack_num %x != rcvd %x => send RST\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state), 
+CONFIG_SOCK_ISS_CLIENT + 1, seg_ack_num );
+#endif
+                        // send RST to remote TCP
                         socket_put_r2t_request( socket_r2tq_xp,
                                                 TCP_FLAG_RST,
                                                 chdev->channel );
-
-                        // report error to local TX client thread
-                        dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADACK );
-
                         break;
                     }
                 }
 
-                // [2] check RST flag                       // receive RST => report error
-                if( seg_rst_set )
-                {
-
-#if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received RST flag\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state) );
-#endif
-                    // update socket state
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ),
-                                          TCP_STATE_BOUND );
-
-                    // signal error to local TX client thread
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_RST );
-
-                    break;
-                }
-
                 // [3] handle security & precedence TODO ... someday
 
@@ -976,6 +1099,7 @@
 
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : received expected SYN-ACK\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid , socket_state_str(socket_state) );
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : received expected SYN-ACK\n",
+__FUNCTION__, pid, fdid , socket_state_str(socket_state) );
 #endif
                     // set socket.tx_una  
